use serenity::prelude::*;
use serenity::{
    framework::standard::{macros::command, Args, CommandResult},
    model::channel::Message,
};

#[command]
#[description = "displays your avatar"]
pub async fn avatar(ctx: &Context, msg: &Message, _args: Args) -> CommandResult {
    if let Ok(member) = &msg.member(&ctx).await {
        if let Some(user_avatar) = &msg.author.avatar_url() {
            msg.channel_id
                .send_message(&ctx, |m| {
                    m.embed(|e| {
                        e.title(format!("Heres {}'s avatar", member.display_name()))
                            .image(user_avatar)
                    })
                })
                .await?;
        };
    }
    Ok(())
}
