use rand::{seq::SliceRandom, thread_rng};
use serenity::prelude::*;
use serenity::{
    framework::standard::{macros::command, Args, CommandResult},
    model::channel::{Message, ReactionType},
};

const CRC_CHOICES: [&'static str; 3] = ["🐀", "🐱", "🧀"];

#[command]
#[aliases("crc")]
#[description = "paper sizzors rock basicly"]
pub async fn cat_rat_cheese(ctx: &Context, msg: &Message, _args: Args) -> CommandResult {
    let mut sent_msg = msg
        .channel_id
        .say(
            &ctx.http,
            "react with your choice, wait for the 3 reactions to load tho",
        )
        .await?;
    for e in &['🐀', '🧀', '🐱'] {
        sent_msg.react(&ctx, *e).await?;
    }
    let mut player_score = 0;
    let mut bot_score = 0;
    while player_score < 3 && bot_score < 3 {
        if let Some(reaction) = sent_msg
            .await_reaction(&ctx)
            .timeout(std::time::Duration::from_secs(10))
            .author_id(msg.author.id)
            .filter(|e| {
                if let ReactionType::Unicode(emoji) = &e.emoji {
                    match emoji.as_ref() {
                        "🐱" | "🐀" | "🧀" => true,
                        _ => false,
                    }
                } else {
                    false
                }
            })
            .await
        {
            if let ReactionType::Unicode(emoji) = &reaction.as_inner_ref().emoji {
                let player: &str = emoji.as_ref();
                let bot = *CRC_CHOICES.choose(&mut thread_rng()).unwrap();
                let message_tail = if player == bot {
                    "draw"
                } else if player == "🐀" {
                    if bot == "🧀" {
                        player_score += 1;
                        "your rat eats the cheese and you win!"
                    } else {
                        // bot = 🐱
                        bot_score += 1;
                        "my cat eats your rat and I win"
                    }
                } else if player == "🧀" {
                    if bot == "🐱" {
                        player_score += 1;
                        "my cat ate your cheese but gets gets poisoned and dies, you win"
                    } else {
                        // bot = 🐀
                        bot_score += 1;
                        "bots rat eats the cheese and you lose"
                    }
                } else if player == "🐱" {
                    if bot == "🐀" {
                        player_score += 1;
                        "your cat eats the rat so you win..."
                    } else {
                        // bot = 🧀
                        bot_score += 1;
                        "your cat eats the cheese but it gets poisoned and dies, I win"
                    }
                } else {
                    "you shouldn't get this message"
                };
                let mut output = format!(
                    "your score: {} - my score {}\nbot picked: {}\n{}",
                    player_score, bot_score, bot, message_tail
                );
                if player_score == 3 {
                    output.push_str("\n**You win!**");
                } else if bot_score == 3 {
                    output.push_str("\n**I win :)**");
                }
                sent_msg.edit(&ctx, |m| m.content(output)).await?;
                &reaction.as_inner_ref().delete(&ctx).await;
            }
        }
    }
    Ok(())
}
