use serenity::prelude::Context;
use serenity::{
    framework::standard::{macros::command, Args, CommandResult},
    model::channel::Message,
};

#[command]
#[description = "responds with pong"]
pub async fn ping(ctx: &Context, message: &Message, _args: Args) -> CommandResult {
    let now = message.timestamp;
    if let Ok(mut msg) = message.channel_id.say(&ctx.http, "Pong! 🏓").await {
        let msg_timestamp = msg.timestamp;
        msg.edit(&ctx, |m| {
            m.content(format!(
                "Pong! 🏓 **took {}ms**",
                (msg_timestamp - now).num_milliseconds()
            ))
        })
        .await?;
    }
    Ok(())
}
